/********************************************
 * UTIA AV CR, v.v.i
 * Signal Processing Department
 * Pod Vodarenskou vezi 4
 * 182 08 Prague
 * Czech Republic
 * web: http://zs.utia.cas.cz
 *
 * Filename: main.c
 * Date: 26.03.2016
 * Authors:
 * Jiri Kadlec <kadlec@utia.cas.cz>
 * Zdenek Pohl <xpohl@utia.cas.cz>
 * Lukas Kohout <kohoutl@utia.cas.cz>
 * Description:
 *
 * Changelog:
 *
 *
 ********************************************/

#ifndef _IMAGE_CORES_H_
#define _IMAGE_CORES_H_
#ifdef __cplusplus
extern "C" {
#endif

#pragma SDS data mem_attribute(yuv_data_in:PHYSICAL_CONTIGUOUS|NON_CACHEABLE)
#pragma SDS data access_pattern(yuv_data_in:SEQUENTIAL, yuv_data_out:SEQUENTIAL)
#pragma SDS data data_mover(yuv_data_in:AXIDMA_SIMPLE)
void pad(unsigned short yuv_data_in[NUMROWS*NUMPADCOLS], unsigned short  yuv_data_out[NUMROWS*NUMCOLS]);

#pragma SDS data access_pattern(inter_pix:SEQUENTIAL, output_edge:SEQUENTIAL)
void sobel_filter(unsigned short inter_pix[NUMROWS*NUMCOLS],unsigned char output_edge[NUMROWS*NUMCOLS]);

#pragma SDS data access_pattern(inter_pix:SEQUENTIAL, output_edge:SEQUENTIAL, original_pix:SEQUENTIAL)
void sobel_filter_pass(unsigned short inter_pix[NUMROWS*NUMCOLS],unsigned char output_edge[NUMROWS*NUMCOLS], unsigned short original_pix[NUMROWS*NUMCOLS]);

#pragma SDS data access_pattern(motion_image:SEQUENTIAL, original:SEQUENTIAL, output_image:SEQUENTIAL)
void combo_image(char pass_through_option, unsigned char motion_image[NUMROWS*NUMCOLS],unsigned short original[NUMROWS*NUMCOLS],unsigned short output_image[NUMROWS*NUMCOLS]);

#pragma SDS data access_pattern(current_pix:SEQUENTIAL)
#pragma SDS data access_pattern(previous_pix:SEQUENTIAL)
#pragma SDS data access_pattern(original:SEQUENTIAL)
#pragma SDS data access_pattern(original_output:SEQUENTIAL)
#pragma SDS data access_pattern(motion_image:SEQUENTIAL)
void diff_image(unsigned char current_pix[NUMROWS*NUMCOLS],unsigned char previous_pix[NUMROWS*NUMCOLS], unsigned short original[NUMROWS*NUMCOLS], unsigned short original_output[NUMROWS*NUMCOLS], unsigned char motion_image[NUMROWS*NUMCOLS]);

#pragma SDS data access_pattern(input_edge:SEQUENTIAL)
#pragma SDS data access_pattern(input_pix:SEQUENTIAL)
#pragma SDS data access_pattern(median_pix:SEQUENTIAL)
#pragma SDS data access_pattern(original_pix:SEQUENTIAL)
void median_char_filter_pass(char threshold, unsigned char input_edge[NUMROWS*NUMCOLS], unsigned short input_pix[NUMROWS*NUMCOLS],unsigned char median_pix[NUMROWS*NUMCOLS], unsigned short original_pix[NUMROWS*NUMCOLS]);

#pragma SDS data mem_attribute(out:PHYSICAL_CONTIGUOUS|NON_CACHEABLE)
#pragma SDS data access_pattern(in:SEQUENTIAL)
#pragma SDS data access_pattern(out:SEQUENTIAL)
#pragma SDS data data_mover(out:AXIDMA_SIMPLE)
void ext(unsigned short in[NUMROWS*NUMCOLS], unsigned short out[NUMROWS*NUMPADCOLS]);

#pragma SDS data mem_attribute(out:PHYSICAL_CONTIGUOUS|NON_CACHEABLE)
#pragma SDS data access_pattern(in:SEQUENTIAL)
#pragma SDS data access_pattern(out:SEQUENTIAL)
#pragma SDS data data_mover(out:AXIDMA_SIMPLE)
void ext_char(unsigned char in[NUMROWS*NUMCOLS], unsigned short out[NUMROWS*NUMPADCOLS]);


#ifdef __cplusplus
};
#endif
#endif
