/********************************************
 * UTIA AV CR, v.v.i
 * Signal Processing Department
 * Pod Vodarenskou vezi 4
 * 182 08 Prague
 * Czech Republic
 * web: http://zs.utia.cas.cz
 * contact: sp@utia.cz
 *
 * Filename: i2c.h
 * Date: 20.09.2016
 * Author: Lukas Kohout <kohoutl@utia.cas.cz>, Zdenek Pohl <xpohl@utia.cas.cz>
 * Description:
 *    I2C controller init
 *
 * Changelog:
 * aarch64 compatibility
 *
 *
 *
 ********************************************/


#ifndef _I2C_IM_HEADER_FILE_
#define _I2C_IM_HEADER_FILE_


#define IM_RSTN 0x01

#define IM_MUX_ADDR           0x70  // 0xE0/0xE1 (PCA9546A)
#define IM_MUX_EDID_DATA      0x01  //
#define IM_MUX_ADV7511_DATA   0x02  // ADV7511
#define IM_MUX_ADV7611_DATA   0x04  // ADV7611
#define IM_MUX_IO_EXP_DATA    0x08  // PCA9555 IO Expander
#define IM_MUX_CAM_DATA       0x10  //

#define IM_I2C_IO_EXP_ADDR    0x20  // 0x40/0x41


int i2c_im_init(UINTPTR i2c_ctrl_base);


#endif
